; -------------------------------------------------------------------------------------------------------------------------
; I don't give a fuck about the licence, do what you want with the code, but crediting the original author is always nice 
; This is a program to extract and uncompress dlls embedded in papras / ursnif executables. This will work only with the M 
; variant, and it has to be unpacked first. 
; Usage in command line : extract.exe <papras exe> 
; For more information about the way it works, see the readme file
;
; To contact me for suggestions or bug reports : Horgh[at]lavabit[dot]com
; -------------------------------------------------------------------------------------------------------------------------

.386 
.model flat,stdcall 
option casemap:none 

include 	aplib/depack.asm
include	windows.inc
include	kernel32.inc 
include	user32.inc 
include 	shell32.inc 
include 	masm32.inc 

includelib	kernel32.lib
includelib	user32.lib 
includelib 	shell32.lib
includelib 	masm32.lib

.data?

hFile				HANDLE ?	; handle on dumped exe
hFile2			HANDLE ?	; handle on dll written on disk
lpBuffer			db 1024 dup (?)	; buffer for the header
lpNumberOfBytesRead		LPVOID ?
lpNbBytesWritten 	dd ?
lpCmdArg 			db 128 dup (?)
WhichDll			db ?			; determine if x86 or x86_64 to be processed next
BufOut			dd ?			; ptr to allocated memory with uncompressed dlls

.data 

Checksum1	dd 4F75CEA7h		; constants
Checksum2	dd 90F8AAB4h
dll1			db "x86",0
dll2			db "x64",0
strpg			db "This program intend to extract and uncompress dlls from the TrojanSpy.Win32Ursnif.gen!M variant. Be aware that previous variants won't work (different implementation).",13,10
			db "Usage : extract.exe <unpacked papras executable>",13,10,0
str2			db "--------------------------------------------------------------------------------",13,10,0
failed			db "The extraction process failed. Verify that your exe meet all the requirements",13,10,0
success		db "Congrats ! The extraction process was successful :)",13,10,0
x86			db "x86 dll extraction... OK !",13,10,0
x64_			db "x64 dll extraction... OK !",13,10,0

.code

start:
	
	invoke GetCL, 1, addr lpCmdArg				; get commandline argument
	invoke StdOut, addr strpg
	invoke StdOut, addr str2
	call ExtractDlls
	test eax, eax
	jne failure
	
	invoke StdOut, addr success
	invoke ExitProcess,0
	
failure:
	invoke StdOut, addr failed
	invoke ExitProcess,0

ExtractDlls proc 

	push ebp
	mov ebp, esp
	sub esp, 0Ch

	; Check if file passed in commandline exists, and open a handle on it if true
	invoke CreateFile, addr lpCmdArg,GENERIC_READ, FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL
	cmp eax, INVALID_HANDLE_VALUE
	jz SomethingWentWrong
	mov hFile, eax
	
	; read the first 1024 octets of the file, check if the file is an executable
	invoke ReadFile,hFile, addr lpBuffer, sizeof lpBuffer, addr lpNumberOfBytesRead, 0 
	mov ebx, offset lpBuffer
	mov ax, "ZM"
	cmp ax, word ptr [lpBuffer]
	jnz SomethingWentWrong
	
	; retieve ptr to dll structure
	mov     eax, [ebx+3Ch]  			; e_lfanew
	add     eax, ebx     				; PE Header RVA 
	movzx   ecx, word ptr [eax+6] 		; retrieve NumberOfSections
	movzx   edx, word ptr [eax+14h]		; retrieve SizeOfOptionalHeader
	imul    ecx, 28h
	add    ecx, eax    					; add ImageBase
	lea     esi, [edx+ecx+40h] 			; (ImageBase + (NumberOfSections * 28)) + SizeOfOptionalHeader + 40 = VA to dll structure

	; test if 'FJ' mark is present on the first word of the structure
LoadStructMark:	
	movzx	eax, word ptr [esi]
	test	ax, ax					 ; test if null, if not jump to cmp
	jnz	short TestIfMark
	movzx	eax, word ptr [esi+2]		; if null, try to get second structure
	lea	esi, [esi+eax*4+14h]
	mov	eax, 4A46h					; and cmp if mark is present
	cmp	[esi], ax
	jz	MarkFound	
	jmp	SomethingWentWrong			; if not, no correct structure was found.

TestIfMark:	
	mov	ecx, 4A46h					
	cmp	ax, cx					
	jz	short MarkFound	
	add	esi, 14h					; if mark is not equal, try on the next structure
	jmp LoadStructMark
	
	; if a correct structure was found, check if its 5th field is equal to the constant
MarkFound:
	movzx eax, byte ptr [WhichDll]		; to determine which checksum is to compare
	test eax, eax
	jne dll64
	mov WhichDll,1
	mov	eax, Checksum1
	jmp next
	
dll64:	
	mov eax, Checksum2
	
next:
	cmp	[esi+0Ch], eax				; now compare constant in the struct and constant in the code
	jnz	 SomethingWentWrong

	; Allocate memory for reading compressed dll
	mov	eax, [esi+8]				; eax =	dll size
	inc	eax						; size + 1
	push	eax						; uBytes
	push    40h           				; uFlags
	call    LocalAlloc
	mov	edi, eax
	test	edi, edi					; test if memory successfully allocated
	jz	SomethingWentWrong

	; Read compressed dll and allocate memory to uncompress it
	mov	eax, [esi+4]				; eax = dll VA
	invoke SetFilePointer,hFile,eax,NULL,FILE_BEGIN				; put FilePointer onto dll VA
	invoke ReadFile,hFile, edi, [esi+8], addr lpNumberOfBytesRead, 0 
	mov	eax, [esi+8]				; eax = dll size
	inc	eax						; size + 1
	push	eax						; uBytes
	push    40h           				; uFlags
	call    LocalAlloc
	
	; uncompress dll with aplib
	mov BufOut, eax
	push	eax						; mem allocated
	push edi						; compressed dll
	call	aP_depack_asm
	cmp	eax, [esi+8]				; check if everything decrypted
	jnz SomethingWentWrong 
	
	movzx eax, byte ptr [WhichDll]
	cmp eax, 2						; has x86 dll already be uncompressed ?
	je x64
	
	; write x86 dll to disk
	invoke CreateFile, addr dll1, GENERIC_WRITE, 0, NULL,CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
	cmp eax, INVALID_HANDLE_VALUE
	jz SomethingWentWrong
	mov hFile2, eax
	invoke WriteFile,hFile2, BufOut, [esi+8], addr lpNbBytesWritten,NULL
	invoke CloseHandle,hFile2
	invoke StdOut, addr x86
	mov WhichDll, 2
	add esi, 14h
	jmp LoadStructMark

	; write x64 dll to disk
x64: 	
	invoke CreateFile, addr dll2, GENERIC_WRITE, 0, NULL,CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL
	cmp eax, INVALID_HANDLE_VALUE
	jz SomethingWentWrong
	mov hFile2, eax
	invoke WriteFile,hFile2, BufOut, [esi+8], addr lpNbBytesWritten,NULL
	invoke StdOut, addr x64_
	invoke CloseHandle,hFile
	invoke CloseHandle,hFile2
	xor eax, eax
	leave
	ret

SomethingWentWrong:
	mov eax, 1
	leave
	ret	

ExtractDlls endp

end start
